widget_k3git/announcement/urls.py
from django.contrib import admin
from django.urls import path

from .views import index, AnnouncementDetailView, AnnouncementCreateView, AnnouncementUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('<int:pk>/details', AnnouncementDetailView.as_view(), name='announcement-details'),
    path('add/', AnnouncementCreateView.as_view(), name='add-announcement'),
    path('<int:pk>/edit', AnnouncementUpdateView.as_view(), name = "edit-announcement")
]

app_name = "announcement"

widget_k3git/forum/urls.py
from django.contrib import admin
from django.urls import path

from .views import index, ForumPostDetailView, ForumPostCreateView, ForumPostUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('forumposts/<int:pk>/details', ForumPostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add', ForumPostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit', ForumPostUpdateView.as_view(), name='forumpost-edit'),
]

app_name = "forum"

widget_k3git/widget_k3git/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('announcements/', include('announcement.urls', namespace="announcement")),
    path('calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('dashboard/', include('dashboard.urls', namespace="dashboard")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('admin/', admin.site.urls),
]

widget_k3git/announcement/models.py
from django.db import models
from django.urls import reverse

# Create your models here.
class Announcement(models.Model):
    title = models.CharField(max_length=100, null = True)
    body = models.TextField(null = True)
    author = models.CharField(max_length=100, null = True)
    pub_datetime = models.DateTimeField(null = True)

    def __str__(self):
        return '{} by {} published {}: {}'.format(self.title, self.author, self.pub_datetime, self.body)
    
    def get_absolute_url(self):
        return reverse('announcement:announcement-details', kwargs={'pk':self.pk})

class Reaction(models.Model):
    reaction_list = [("Like", "Like"), ("Heart", "Heart"), ("Angry", "Angry")]
    name = models.CharField(max_length=10, choices = reaction_list, default = "Like")
    tally = models.IntegerField(null = True)
    announcement = models.ForeignKey(Announcement, on_delete=models.CASCADE)

    def __str__(self):
        return '{}: {}'.format(self.name, self.tally)

widget_k3git/announcement/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import Announcement

def index(request):
    return render(request, 'announcement/announcement.html', {'announcement': Announcement.objects.all()})

class AnnouncementDetailView(DetailView):
    model = Announcement

    def get(self, request, pk):
        return render(request, 'announcement/announcement-details.html', {'announcement': self.model.objects.get(pk=pk)})
    
class AnnouncementCreateView(CreateView):
    model = Announcement
    fields = '__all__'
    template_name = 'announcement/announcement-add.html'

class AnnouncementUpdateView(UpdateView):
    model = Announcement
    fields = '__all__'
    template_name = 'announcement/announcement-edit.html'

widget_k3git/announcement/templates/announcement/announcement-add.html
{% extends 'base.html' %}

{% block title %}Add Announcement{% endblock %}
{% block content %}
<h1>Add a new announcement:</h1><br>
<form action="" method="post">
	{% csrf_token %}
	{{ form.as_p }}
	<input type="submit" value="Save New Announcement">
</form>
{% endblock %}
{% block scripts %}

{% endblock %}

widget_k3git/announcement/templates/announcement/announcement-details.html
{% extends 'base.html' %}

{% block title %}{{ announcement.title }}{% endblock %}
{% block content %}
<h1>{{ announcement.title }}</h1>
<h3>by {{ announcement.author }}</h3>
<h3> {{ announcement.pub_datetime }}</h3>
<h3> {{ announcement.body }}<br>

	{% for reaction in announcement.reaction_set.all %}
		{{ reaction.name }}: {{ reaction.tally }}<br>
	{% endfor %}
</h3>
{% endblock %}
{% block scripts %}
<a href="/announcements/{{ announcement.pk }}/edit"><input type="submit" value="Edit Announcement"></a>
{% endblock %}

widget_k3git/announcement/templates/announcement/announcement-edit.html
{% extends 'base.html' %}

{% block title %}Edit Announcement{% endblock %}
<h1>Edit Announcement:</h1>
{% block content %}
<form action="" method="post">
	{% csrf_token %}
	{{ form.as_p }}
	<input type="submit" value="Save Changes to Announcement">
</form>
{% endblock %}
{% block scripts %}

{% endblock %}

widget_k3git/announcement/templates/announcement/announcement.html
{% extends 'base.html' %}

{% block title %}Widget's Announcement Board{% endblock %}
{% block content %}
<h1>Welcome to Widget's Announcement Board!</h1>
<h3>
	{% for announcement in announcement %}
		<a href="{{ announcement.get_absolute_url }}">{{ announcement.title }} by {{ announcement.author }}</a><br>
	{% endfor %}
</h3>
{% endblock %}
{% block scripts %}
<a href="/announcements/add"><input type="submit" value="New Announcement"></a><br><br>
<a href="/dashboard">Dashboard</a><br>
<a href="/assignments">Assignments</a><br>
<a href="/forum">Forum</a><br>
<a href="/calendar">Calendar</a>
{% endblock %}